//BeOSRADIO Probe

#include "RadioProbeLink.h"
#include "RadioProbeConstants.h"
#include <Looper.h>
#include <Window.h>

RadioProbeLink::RadioProbeLink(BRect frame, BLooper *looper)
	: BView(frame, "link", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_PULSE_NEEDED)
{
	mLooper = looper;
	mLinkDisabled = false;
}

void RadioProbeLink::AttachedToWindow()
{
	BView *v = Parent();
	if (v)
	{
		SetViewColor(v->ViewColor());
		SetLowColor(v->LowColor());
		SetHighColor(v->HighColor());
	}

	SetFont(be_plain_font);
	SetFontSize(10);
}

void RadioProbeLink::Draw(BRect updateRect)
{
	DrawString("Listen at: ", BPoint(0,9));
	PushState();
	if (!mLinkDisabled)
		SetHighColor(0,0,255);
	DrawString("http://www.BeOSRADIO.com/playlist.m3u");
	PopState();
}

void RadioProbeLink::MouseDown(BPoint where)
{
	if (mLinkDisabled)
		return;

	mLinkDisabled = true;
	mLooper->PostMessage(P_LAUNCH_PLAYLIST);
	Window()->SetPulseRate(5000000);
	Invalidate();
}

void RadioProbeLink::Pulse()
{
	mLinkDisabled = false;
	Window()->SetPulseRate(0);
	Invalidate();
}
