//BeOSRADIO Probe

#include "RadioProbeProxy.h"
#include "RadioProbeConstants.h"
#include <stdio.h>
#include <View.h>
#include <Looper.h>
#include <CheckBox.h>
#include <TextControl.h>
#include <Button.h>

RadioProbeProxy::RadioProbeProxy(BHandler *replyto, BMessage *proxy_info)
	: BWindow(BRect(150,130,530,200), "HTTP Proxy Settings", B_FLOATING_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL,
	B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS),
	mReplyTo(replyto)
{
	char port_string[20];
	const char *server;
	uint16 port;
	bool enable = false;
	status_t err;
	
	if (((err = proxy_info->FindBool("enable", &enable)) < B_OK) ||
		((err = proxy_info->FindInt16("port", (int16*)&port)) < B_OK) ||
		((err = proxy_info->FindString("server", &server)) < B_OK))
	{
		port = 8080;
		enable = false;
		server = B_EMPTY_STRING;	
	}
	
	sprintf(port_string, "%d", port);

	BView *view = new BView(Bounds(), "view", B_FOLLOW_ALL, 0);
	view->SetFont(be_plain_font);
	view->SetViewColor(255, 152, 51);
	view->SetLowColor(255, 152, 51);
	AddChild(view);
	BCheckBox *checkbox = new BCheckBox(BRect(10,10,120,30), "enable", "Enable Proxy", NULL);
	if (enable)
		checkbox->SetValue(B_CONTROL_ON);
	view->AddChild(checkbox);
	BTextControl *server_input = new BTextControl(BRect(10,35,220,50), "server", "Server:", server, NULL);
	server_input->SetDivider(40);
	view->AddChild(server_input);
	BTextControl *port_input = new BTextControl(BRect(240,35,350,50), "port", "Port:", port_string, NULL);
	port_input->SetDivider(30);
	view->AddChild(port_input);
}

bool RadioProbeProxy::QuitRequested()
{
	BMessenger messenger(mReplyTo);
	BMessage set_server(P_SET_SERVER);
	status_t err;
	int32 _port;
	uint16 port;

	sscanf(((BTextControl *)FindView("port"))->Text(), "%ld", &_port);
	port = _port;
	if (((err = set_server.AddBool("enable", (((BCheckBox *)FindView("enable"))->Value() == B_CONTROL_ON)?true:false)) == B_OK) &&
		((err = set_server.AddString("server", ((BTextControl *)FindView("server"))->Text())) == B_OK) &&
		((err = set_server.AddInt16("port", port)) == B_OK))
			messenger.SendMessage(&set_server);

	return true;
}
