//BeOSRADIO Probe

#include "RadioProbeWindow.h"
#include "RadioProbeView.h"
#include "RadioProbeConstants.h"
#include <Application.h>
#include <File.h>
#include <Path.h>
#include <FindDirectory.h>
#include <stdio.h>

RadioProbeWindow::RadioProbeWindow()
	: BWindow(BRect(100,80,360,150), "BeOSRADIO", B_TITLED_WINDOW,
	B_WILL_ACCEPT_FIRST_CLICK | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS)
{
	SetSizeLimits(260, 1610, 48, 70);
	RadioProbeView *v = new RadioProbeView(Bounds());
	AddChild(v);
}

RadioProbeWindow::RadioProbeWindow(BMessage *archive)
	: BWindow(archive)
{
	//pre 0.24 compatibility
	if (archive->HasMessage("_views") == false)
	{
		RadioProbeView *v = new RadioProbeView(Bounds());
		AddChild(v);
	}
	
	//pre 0.25 compatibility
	SetFlags(B_WILL_ACCEPT_FIRST_CLICK | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS);
	SetSizeLimits(260, 1610, 48, 70);
}

bool RadioProbeWindow::QuitRequested()
{
	BPath path;
	BFile file;
	BMessage archive;
	status_t err;

	if (((err = find_directory(B_USER_SETTINGS_DIRECTORY, &path)) < B_OK) ||
		((err = path.Append("BeOSRadioProbe")) < B_OK) ||
		((err = Archive(&archive, true)) < B_OK) ||
		((err = file.SetTo(path.Path(), B_WRITE_ONLY | B_ERASE_FILE | B_CREATE_FILE)) < B_OK) ||
		((err = archive.Flatten(&file)) < B_OK))
	{
		fprintf(stderr, "BeOSRadioProbe: Unable to save preferences (%s)\n", strerror(err));
	}
	file.Unset();

	Hide();

	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}
